#ifndef _INIT_H_
#define _INIT_H_

/**
 * initPose check initial position and orientation
 * 
 * @requires none
 * @effect set initial position and orientation
 * @modifies initPlace, initOrient
 */
void initPose(void);
/*
 * initTurn turns the robot towards its proper initial position
 *
 * The current proper orientation is 1
 *
 * @requires 0 <= currentOrient <= 3
 * @effects robot is turned towards orientation 1 
 * @modifies currentOrient, currentSide
 */
int initTurn(void);

#endif
